#define TICK 500 //us (!!!!! CAREFULL NEVER GREATER THAN 1E4 !!!!!)

#define MODULE
#include <linux/module.h>
#include <linux/errno.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/interrupt.h>

#include <asm/system.h>
#include <asm/smp.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/bitops.h>
#include <asm/atomic.h>
#include <asm/desc.h>
#include <asm/delay.h>

#include <rtai_fifos.h>
#include <rtai.h>

#define CMDF 0

#define FLOAT float


static void rt_timer_tick(void)
{
	char wakeup;
	rtf_put(CMDF, &wakeup, sizeof(wakeup));
	rt_times.tick_time = rt_times.intr_time;
	rt_times.intr_time = rt_times.tick_time + rt_times.periodic_tick;
	if (rt_times.tick_time >= rt_times.linux_time) {
		rt_times.linux_time += rt_times.linux_tick;
		rt_pend_linux_irq(0);
	} 
}


int init_module(void)
{
	rtf_create_using_bh(CMDF, 4, 0);
	rt_mount_rtai();
	rt_request_timer(rt_timer_tick, imuldiv(TICK, FREQ_8254, 1E6)); 
	return 0;
}

void cleanup_module(void)
{
	rt_free_timer();
	rtf_destroy(CMDF);
	rt_umount_rtai();
	return;
}
